<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="100px">
      <el-form-item label="题库类别" prop="categoryId">
        <el-select clearable v-model="queryParams.categoryId" placeholder="请选择题库类别" @change="handleQuery">
          <el-option v-for="item in  category" :key="item.id" :label="item.typeValue" :value="item.id">
          </el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="习题种类：" prop="species">
        <!-- 1填空，2选择，3解答 -->
        <el-select clearable v-model="queryParams.species" placeholder="请选择习题种类" @change="handleQuery">
          <el-option v-for="item in [
            { label: '全部', value: '' },
            { label: '填空', value: '1' },
            { label: '选择', value: '2' },
            { label: '解答', value: '3' },
          ]" :key="item.value" :label="item.label" :value="item.value">
          </el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="类型" prop="type">
        <el-select clearable v-model="queryParams.type" placeholder="请选择类型" @change="handleQuery">
          <el-option v-for="item in [
            { label: '全部', value: '' },
            { label: '典例精讲', value: '1' },
          ]" :key="item.value" :label="item.label" :value="item.value">
          </el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="强度分类：" prop="intensity">
        <!-- 1基础，2中等，3提高 -->
        <el-select clearable v-model="queryParams.intensity" placeholder="请选择强度" @change="handleQuery">
          <el-option v-for="item in [
            { label: '全部', value: '' },
            { label: '基础', value: '1' },
            { label: '中等', value: '2' },
            { label: '提高', value: '3' },
          ]" :key="item.value" :label="item.label" :value="item.value">
          </el-option>
        </el-select>
      </el-form-item>
      <!-- <el-form-item label="题目" prop="topic">
        <el-input
          v-model="queryParams.topic"
          placeholder="请输入题目"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item> -->
      <!-- <el-form-item label="正确答案" prop="rightAnswers">
        <el-input
          v-model="queryParams.rightAnswers"
          placeholder="请输入正确答案"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item> -->
      <!-- <el-form-item label="正确答案图片" prop="rightAnswersPic">
        <el-input
          v-model="queryParams.rightAnswersPic"
          placeholder="请输入正确答案图片"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item> -->
      <!-- <el-form-item label="解答过程" prop="resolveCourse">
        <el-input
          v-model="queryParams.resolveCourse"
          placeholder="请输入解答过程"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item> -->
      <!-- <el-form-item label="解答视频" prop="resolveVideo">
        <el-input
          v-model="queryParams.resolveVideo"
          placeholder="请输入解答视频"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item> -->
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <!-- <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['school-paper:questionBank:add']"
          >新增题目</el-button
        >
      </el-col> -->
      <!-- <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['school-paper:questionBank:edit']"
          >修改</el-button
        >
      </el-col> -->
      <!-- <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['school-paper:questionBank:remove']"
          >删除</el-button
        >
      </el-col> -->
      <!-- <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-hasPermi="['school-paper:questionBank:export']"
          >导出</el-button
        >
      </el-col> -->
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <div class="app-container-list">
      <div class="app-container-list-item" v-for="(item, index) in questionBankList" :key="index">
        <div class="app-container-list-item-title">选择题</div>
        <div class="app-container-list-item-html" v-html="item.topic"></div>
        <div class="app-container-list-item-footer">
          <el-button icon="el-icon-edit-outline" @click="handleUpdate(item)">查看</el-button>
        </div>
      </div>
    </div>
    <!-- <el-table
      v-loading="loading"
      :data="questionBankList"
      @selection-change="handleSelectionChange"
    >
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="主键id" align="center" prop="id" v-if="true" />
      <el-table-column label="类别id" align="center" prop="categoryId" />
      <el-table-column
        label="习题种类：1填空，2选择，3解答"
        align="center"
        prop="species"
      />
      <el-table-column label="阶段id" align="center" prop="phaseId" />
      <el-table-column label="类型：1典例精讲" align="center" prop="type" />
      <el-table-column
        label="强度：1基础，2中等，3提高"
        align="center"
        prop="intensity"
      />
      <el-table-column label="题目" align="center" prop="topic" />
      <el-table-column label="正确答案" align="center" prop="rightAnswers" />
      <el-table-column
        label="正确答案图片"
        align="center"
        prop="rightAnswersPic"
      />
      <el-table-column label="解答过程" align="center" prop="resolveCourse" />
      <el-table-column label="解答视频" align="center" prop="resolveVideo" />
      <el-table-column label="备注" align="center" prop="remark" />
      <el-table-column
        label="状态：0正常，1删除"
        align="center"
        prop="status"
      />
      <el-table-column
        label="操作"
        align="center"
        class-name="small-padding fixed-width"
      >
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['school-paper:questionBank:edit']"
            >修改</el-button
          >
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['school-paper:questionBank:remove']"
            >删除</el-button
          >
        </template>
      </el-table-column>
    </el-table> -->

    <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNum" :limit.sync="queryParams.pageSize"
      @pagination="getList" />

    <!-- 添加或修改题库主对话框 -->
    <template v-if="open">
      <el-dialog :title="title" :visible.sync="open" width="70%" append-to-body destroy-on-close>
        <el-form ref="form" :model="form" :rules="rules" label-width="120px" label-position="top"
          class="app-container-form">
          <el-row :gutter="24">
            <el-col :span="6">
              <el-form-item label="题库类别" prop="categoryId">
                <el-select clearable v-model="form.categoryId" placeholder="请选择题库类别">
                  <el-option v-for="item in category" :key="item.id" :label="item.typeValue" :value="item.id">
                  </el-option>
                </el-select>
              </el-form-item>
              <el-form-item label="年级阶段" prop="phaseId">
                <el-select clearable v-model="form.phaseId" placeholder="请选择阶段" @change="handleQuery">
                  <el-option v-for="item in [
                    { label: '高一', value: '1' },
                    { label: '高二', value: '2' },
                    { label: '高三', value: '3' },
                  ]" :key="item.value" :label="item.label" :value="item.value">
                  </el-option>
                </el-select>
              </el-form-item>
              <el-form-item label="强度分类：" prop="intensity">
                <!-- 1基础，2中等，3提高 -->
                <el-select clearable v-model="form.intensity" placeholder="请选择强度">
                  <el-option v-for="item in [
                    { label: '基础', value: '1' },
                    { label: '中等', value: '2' },
                    { label: '提高', value: '3' },
                  ]" :key="item.value" :label="item.label" :value="item.value">
                  </el-option>
                </el-select>
              </el-form-item>
              <el-form-item label="习题种类：" prop="species">
                <!-- 1填空，2选择，3解答 -->
                <el-select clearable v-model="form.species" placeholder="请选择习题种类" @change="changeSpecies">
                  <el-option v-for="item in [
                    { label: '填空', value: '1' },
                    { label: '选择', value: '2' },
                    { label: '解答', value: '3' },
                  ]" :key="item.value" :label="item.label" :value="item.value">
                  </el-option>
                </el-select>
              </el-form-item>
            </el-col>
            <el-col :span="18">
              <el-form-item label="题目" prop="topic">
                <editor v-model="form.topic" :min-height="192" :iconType="['image']" />
              </el-form-item>
              <template v-if="[1, '1', 3, '3'].includes(form.species)">
                <el-form-item label="答案" prop="answer">
                  <editor v-model="form.answer" :min-height="192" :iconType="['image']" />
                </el-form-item>
                <el-form-item label="答案图片" prop="rightAnswersPic">
                  <imageUpload :limit="9" v-model="form.rightAnswersPic" />
                </el-form-item>
              </template>
              <template v-if="[2, '2'].includes(form.species)">
                <el-form-item label="选项" prop="options">
                  <div class="app-container-form-check">
                    <i class="el-icon-circle-plus-outline app-container-form-check-add"
                      v-if="!form.options || !form.options.length" @click="clickAddoptions"></i>
                    <div v-for="(item, index) in form.options" :key="index" class="app-container-form-check-item">
                      <span class="app-container-form-check-item-type">{{
                        index | filterType(form.options)
                      }}</span><i v-if="index + 1 === form.options.length"
                        class="el-icon-circle-plus-outline app-container-form-check-item-add"
                        @click="clickCheckItemAdd(index)"></i>
                      <i class="el-icon-remove-outline app-container-form-check-item-del" v-else
                        @click="clickCheckItemDel(index)"></i>
                      <editor v-model="item.html" :min-height="192" :iconType="['image']" />
                    </div>
                  </div>
                </el-form-item>
                <el-form-item label="标准答案" prop="rightAnswers" v-if="form.options && form.options.length">
                  <el-radio-group v-model="form.rightAnswers">
                    <el-radio :label="index" v-for="(item, index) in form.options" :key="index">{{ index |
                      filterType(form.options) }}</el-radio>
                  </el-radio-group>
                </el-form-item>
              </template>
              <el-form-item label="典例精讲" prop="explain">
                <el-switch @change="changeExplain" v-model="form.explain" active-color="#409eff">
                </el-switch>
              </el-form-item>
              <template v-if="form.explain">
                <el-form-item label="解答过程" prop="resolveCourse">
                  <editor v-model="form.resolveCourse" :min-height="192" :iconType="['image']" />
                </el-form-item>
                <el-form-item label="解答视频" prop="resolveVideo">
                  <fileUpload v-model="form.resolveVideo" :limit="1" :fileSize="1024" :fileType="['mp4', 'mp3']" />
                </el-form-item>
              </template>
            </el-col>
          </el-row>
          <!-- <el-form-item label="备注" prop="remark">
          <el-input v-model="form.remark" placeholder="请输入备注" />
        </el-form-item> -->
        </el-form>
        <div slot="footer" class="dialog-footer">
          <el-button :loading="buttonLoading" type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </el-dialog>
    </template>
  </div>
</template>

<script>
import {
  listErrorList,
  getErrorList,
  delQuestionBank,
  addQuestionBank,
  updateQuestionBank,
  questionType
} from "@/api/school-paper/errorList";

export default {
  name: "QuestionBank",
  data() {
    return {
      category: [], // 题库类别
      // 按钮loading
      buttonLoading: false,
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 题库主表格数据
      questionBankList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        categoryId: undefined,
        species: undefined,
        phaseId: undefined,
        type: undefined,
        intensity: undefined,
        topic: undefined,
        rightAnswers: undefined,
        rightAnswersPic: undefined,
        resolveCourse: undefined,
        resolveVideo: undefined,
        status: undefined,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {},
    };
  },
  filters: {
    filterType(val, list) {
      if (val >= 0) {
        let arr = [
          "A",
          "B",
          "C",
          "D",
          "E",
          "F",
          "G",
          "H",
          "I",
          "J",
          "K",
          "L",
          "M",
          "N",
          "O",
          "P",
          "Q",
          "R",
          "S",
          "T",
          "U",
          "V",
          "W",
          "X",
          "Y",
          "Z",
        ];
        return arr[val];
      } else {
        return val;
      }
    },
  },
  created() {
    this.getList();
    this.questionType()
  },
  methods: {
    changeExplain(e) {
      let self = this;
      if (e) {
        self.$refs.form.clearValidate();
        self.initleRules();
        self.isExplan(e);
        self.isSpec(self.form.species);
      }
    },
    isExplan(val) {
      let self = this;
      if (val) {
        self.$set(self.rules, "resolveCourse", [
          {
            required: true,
            message: "解答过程不能为空",
            trigger: ["blur", "change"],
          },
        ]);
        self.$set(self.rules, "resolveVideo", [
          {
            required: true,
            message: "解答视频不能为空",
            trigger: ["blur", "change"],
          },
        ]);
      }
    },
    changeSpecies(e) {
      let self = this;
      self.$refs.form.clearValidate();
      self.initleRules();
      self.isSpec(e);
      self.isExplan(self.form.explain);
    },
    isSpec(val) {
      let self = this;
      switch (parseInt(val)) {
        case 1:
          self.$set(self.rules, "answer", [
            {
              required: true,
              message: "答案不能为空",
              trigger: ["blur", "change"],
            },
          ]);
          self.$set(self.rules, "rightAnswersPic", [
            {
              required: true,
              message: "答案图片不能为空",
              trigger: ["blur", "change"],
            },
          ]);
          break;
        case 2:
          self.$set(self.rules, "options", [
            {
              required: true,
              message: "选项不能为空",
              trigger: ["blur", "change"],
            },
          ]);
          self.$set(self.rules, "rightAnswers", [
            {
              required: true,
              message: "标准答案不能为空",
              trigger: ["blur", "change"],
            },
          ]);
          break;
        case 3:
          self.$set(self.rules, "answer", [
            {
              required: true,
              message: "答案不能为空",
              trigger: ["blur", "change"],
            },
          ]);
          self.$set(self.rules, "rightAnswersPic", [
            {
              required: true,
              message: "答案图片不能为空",
              trigger: ["blur", "change"],
            },
          ]);
          break;
      }
    },
    initleRules() {
      this.rules = {
        categoryId: [
          { required: true, message: "题库类别不能为空", trigger: "change" },
        ],
        species: [
          {
            required: true,
            message: "习题种类不能为空",
            trigger: "change",
          },
        ],
        phaseId: [
          { required: true, message: "年级阶段不能为空", trigger: "change" },
        ],
        intensity: [
          {
            required: true,
            message: "强度分类不能为空",
            trigger: "change",
          },
        ],
        topic: [{ required: true, message: "题目不能为空", trigger: "change" }],
      };
    },
    /** 查询题库主列表 */
    getList() {
      this.loading = true;
      listErrorList(this.queryParams).then((response) => {
        this.questionBankList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: undefined,
        answer: undefined,
        categoryId: undefined,
        species: undefined,
        phaseId: undefined,
        type: undefined,
        intensity: undefined,
        topic: undefined,
        rightAnswers: undefined,
        rightAnswersPic: undefined,
        resolveCourse: undefined,
        resolveVideo: undefined,
        remark: undefined,
        status: undefined,
        createTime: undefined,
        updateTime: undefined,
        createBy: undefined,
        updateBy: undefined,
        options: [],
        explain: false,
      };
      this.resetForm("form");
    },
    clickAddoptions() {
      if (this.form.options && !this.form.options.length) {
        this.form.options.unshift({
          html: "",
        });
      }
    },
    clickCheckItemAdd(index) {
      let self = this,
        isKong = false;
      if (index < 25) {
        self.form.options.forEach((item, ik) => {
          if (self.IsEmptyStr(self.getWangEditorText(item.html + "") + "")) {
            isKong = true;
          }
        });
        if (isKong) {
          self.$message.warning("请填写选项内容");
        } else {
          self.form.options.push({
            html: "",
          });
        }
      } else {
        self.$message.warning("最多26个选项");
      }
    },
    clickCheckItemDel(index) {
      let self = this;
      self
        .$confirm("确定删除此项吗?", "提示", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning",
        })
        .then(() => {
          self.$delete(this.form.options, index);
        })
        .catch(() => { });
    },
    // 判断字符串是否为空
    IsEmptyStr(str) {
      str = str.toString();
      if (
        str == null ||
        str == "null" ||
        str == undefined ||
        str == "undefined" ||
        str.match(/^[\s]*$/)
      ) {
        return true;
      } else {
        return false;
      }
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map((item) => item.id);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加题库主";
      this.initleRules();
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.loading = true;
      this.reset();
      const id = row.id || this.ids;
      getErrorList(id).then((response) => {
        this.loading = false;
        this.form = response.data;
        this.open = true;
        this.title = "修改题库主";
      });
    },
    getWangEditorText(str) {
      console.log(str, "========str");
      if (str) {
        return str
          .replace(/<[^<p>]+>/g, "") // 将所有<p>标签 replace ''
          .replace(/<[</p>$]+>/g, "") // 将所有</p>标签 replace ''
          .replace(/&nbsp;/gi, "") // 将所有 空格 replace ''
          .replace(/<[^<br/>]+>/g, ""); // 将所有 换行符 replace ''
      } else {
        return "";
      }
    },
    isEditor(itemName) {
      let self = this;
      if (self.IsEmptyStr(self.getWangEditorText(self.form[itemName]) + "")) {
        self.$set(self.form, itemName, undefined);
        self.$refs.form.validateField(itemName);
      }
    },
    /** 提交按钮 */
    submitForm() {
      let self = this,
        isKong = false;
      self.isEditor("topic");
      if (self.form.options && self.form.options.length) {
        self.form.options.forEach((item, ik) => {
          console.log(item.html);
          if (self.IsEmptyStr(self.getWangEditorText(item.html + "") + "")) {
            isKong = true;
          }
        });
        if (isKong) {
          self.$message.warning("请填写选项内容");
          self.$refs.form.validateField("options");
        }
      }
      if (self.form.explain) {
        self.isEditor("resolveCourse");
      }
      this.$refs["form"].validate((valid) => {
        if (valid) {
          console.log("规则通过");
          this.buttonLoading = true;
          if (this.form.id != null) {
            updateQuestionBank(this.form)
              .then((response) => {
                this.$modal.msgSuccess("修改成功");
                this.open = false;
                this.getList();
              })
              .finally(() => {
                this.buttonLoading = false;
              });
          } else {
            addQuestionBank(this.form)
              .then((response) => {
                this.$modal.msgSuccess("新增成功");
                this.open = false;
                this.getList();
              })
              .finally(() => {
                this.buttonLoading = false;
              });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal
        .confirm('是否确认删除题库主编号为"' + ids + '"的数据项？')
        .then(() => {
          this.loading = true;
          return delQuestionBank(ids);
        })
        .then(() => {
          this.loading = false;
          this.getList();
          this.$modal.msgSuccess("删除成功");
        })
        .catch(() => { })
        .finally(() => {
          this.loading = false;
        });
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download(
        "school-paper/questionBank/export",
        {
          ...this.queryParams,
        },
        `questionBank_${new Date().getTime()}.xlsx`
      );
    },
    //题库类别
    questionType() {
      questionType({ pageSize: 9999, pageNum: 1 }).then((res) => {
        this.category = res.rows
        // console.log(res,'this.questionBankList======')
      })
    },
  },
};
</script>

<style lang="scss" scoped>
.app-container {
  &-list {
    padding: 20px 40px;
    display: flex;
    flex-wrap: wrap;
    justify-content: space-between;

    &-item {
      padding: 15px 20px;
      width: calc(33% - 40px);
      border-radius: 5px;
      background-color: #f1efef;
      margin-bottom: 20px;

      &-title {
        font-size: 18px;
        margin-bottom: 10px;
      }

      &-html {
        font-size: 16px;
        margin-bottom: 20px;
        word-break: break-all;
        text-overflow: ellipsis;
        display: -webkit-box;
        -webkit-box-orient: vertical;
        -webkit-line-clamp: 3;
        /* 超出几行省略 */
        overflow: hidden;
      }

      &-footer {
        display: flex;
        justify-content: right;

        button {
          background: transparent;
          border: none;
        }

        button::after {
          border: none;
        }
      }
    }

    &-item:last-child {
      margin-bottom: 0px;
    }
  }

  &-form {
    height: 60vh;
    overflow-x: hidden;
    overflow-y: auto;

    &-check {
      &-add {
        font-size: 30px;
        color: #409eff;
        cursor: pointer;
      }

      &-item {
        margin-bottom: 12px;

        &-type {
          display: inline-block;
          padding: 8px 15px;
          border: 1px solid #eeecec;
          font-size: 16px;
          line-height: 16px;
          border-radius: 5px;
          margin: 0px 12px 15px 0px;
        }

        &-add,
        &-del {
          font-size: 25px;
          cursor: pointer;
        }

        &-add {
          color: #409eff;
        }

        &-del {
          color: #f56c6c;
        }
      }

      &-item:last-child {
        margin-bottom: 0rpx;
      }
    }
  }
}
</style>
